#
#
# ̿   perl CGI  
#
#
# ָ>   Perl ̿ CGI ۼ  ϰ   Դϴ.
#         Ժη ļ ϴ  Ұմϴ.
#        [ Խ] Բ մϴ.
#
#
#      :  (mio, )
# Ҽ     : 泲б ǻ Ƹ C.P.U. 8
# Ȩ : http://warema.chungnam.ac.kr/~mio/
# ̸   : mio\@warema.chungnam.ac.kr
# ICQ      : 14795244
#
#
# 1999.02.10 : put_err_msg(߰)
# 1998,07.07 : make_passwd()
# 1998.07.06 : sub get_user_cryptedpasswd, update_passwd
# 1998.06.21 : wordwrap
# 1998.03.30 : get_rec_size
# 1998.03.26 : no_html
# 1998.03.23 : get_date_time_format
# 1998.02.20 : put_err_msg
# 1998.02.19 : swd, seedchar, add_passwd, add_group(Ϻι̿)
# 1998.02.?? : parser, get_date_time, put_back_button, put_err_msg(Ϻι̿)
#
#


#
# parseϴ 
#
# %entries .
#
sub parser
{
    if ( $ENV{'REQUEST_METHOD'} eq "GET" )
    {
        $buffer = $ENV{'QUERY_STRING'};
    }
    else
    {
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'} );
    }

    @pairs = split( /&/, $buffer);
    foreach $pair ( @pairs )
    {
        ( $name, $value ) = split ( /=/, $pair );
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
        $entries{$name} = $value;
    }

    return %entries;
}



#
# ð ¥ ϴ 
#
# ex) ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = &get_date_time;
#
sub get_date_time
{
    ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
    $mon = ($mon + 1);
    if ($sec < 10)  { $sec = "0$sec"; }
    if ($min < 10)  { $min = "0$min"; }
    if ($hour < 10) { $hour = "0$hour"; }
    if ($mday < 10) { $mday = "0$mday"; }
    if ($mon < 10)  { $mon = "0$mon"; }

    return ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst);
}



#
# ð ¥ ϴ 
#
# ex) $time = &get_date_time_format('_yyyy_ _mon_ _mday_ _hour_ _min_ _sec_');
#
sub get_date_time_format
{
    $form = $_[0]; #  ù° ̴, ι° $_[1] ...

    ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
    $mon = ($mon + 1);
    if ($sec < 10)  { $sec = "0$sec"; }
    if ($min < 10)  { $min = "0$min"; }
    if ($hour < 10) { $hour = "0$hour"; }
    if ($mday < 10) { $mday = "0$mday"; }
    if ($mon < 10)  { $mon = "0$mon"; }
    $form =~ s/_yyyy_/19$year/;
    $form =~ s/_mon_/$mon/;
    $form =~ s/_mday_/$mday/;
    $form =~ s/_hour_/$hour/;
    $form =~ s/_min_/$min/;
    $form =~ s/_sec_/$sec/;

    return $form;
}



#
# ǵư ư ִ 
#
# ex) &put_back_button("ư");
#
sub put_back_button
{
    $msg = $_[0];

    print qq(
    <A HREF=javascript:history.back()>$msg</A>
    );
}



#
#  ޽ 
#
# ex) &put_err_msg("   ϴ.");
#
sub put_err_msg
{
    $msg = $_[0];
    $cmd = $_[1]; # 1999.2.10 ߰

    print qq(
    <BR>
    <FONT COLOR=red>
    ##  : $msg ##
    </FONT>
    <BR>
    <BR>
    );
    
    if ($cmd eq "exit") { # 1999.2.10 ߰ : ޽ ǥϰ ؾ  쿡 .
    	exit(1);
    }
}



#
# ȣȭϴ 
#
# $passcode returen
#
sub make_passwd
{
    $passwd = $_[0]; #  ù° ̴, ι° $_[1] ...
    $options = $_[1]; 


    # random seed
    if ($options eq "nor") # "nor"̸ RANDOM  ʴ´.
    {
        $salt = substr($passwd, 0, 2);
    }
    else
    {
        srand($$^time&$ENV{RANDOM});
        $salt = seedchar().seedchar();
    }
    $passcode = crypt($passwd, $salt);
    return $passcode;
}



#
#   ȣȭ  ʿ 
#
# make_passwd ʿ 
#
sub seedchar
{    # from Randal Schwarz
    ('a'..'z','A'..'Z','0'..'9','.','/')[rand(64)];
}



#
#   ȣϿ ȣ ߰ϴ 
#
sub add_passwd
{
    $passwd_file = $_[0];
    $id = $_[1];
    $uncrypted_passwd = $_[2];

    $passcode = &make_passwd($uncrypted_passwd);

    print "sp=$passwd_file<BR>$id<BR>$uncrypted_passwd<BR>";

    open(PASSWD, "<$passwd_file") || print "1 Ұմϴ.<BR>";
    @rec = <PASSWD>;
    close(PASSWD);

    open(PASSWD, "+<$passwd_file") || print "2 Ұմϴ.<BR>";
    for $i (0 .. $#rec)
    {
        chop($rec[$i]);
        if ($rec[$i] ne "")
        {
            print PASSWD "$rec[$i]\n";
        }
    }
    print PASSWD "$id:$passcode\n";
    close(PASSWD);
}



#
#   ׷Ͽ ׷ ߰ϴ 
#
sub add_group
{
    $group_file = $_[0];
    $id = $_[1];
    $group = $_[2];
    print "f=$group_file<BR>id=$id<BR>g=$group<BR>";
    open(GROUP, "<$group_file") || print "1 Ұմϴ.<BR>";
    @rec = <GROUP>;
    close(GROUP);

    open(GROUP, "+<$group_file") || print "2 Ұմϴ.<BR>";
    for $i (0 .. $#rec)
    {
        chop($rec[$i]);
        if ($rec[$i] ne "")
        {
            print "r$#rec=$rec[$i]<BR>";
            ($group_name, $group_member) = split(":", $rec[$i]);
            print "$group_name,$group_member<BR>";
            if ($group_name eq $group)
            {
                print GROUP "$rec[$i] $id\n";
            }
            else
            {
                print GROUP "$rec[$i]\n";
            }
        }
    }
    close(GROUP);
}



#
# ڵ ũ⸦ ϴ 
#
sub get_rec_size
{
    local(%cnt) = @_;
#    local $rec_size, $key; # ʿ. perl -w  ߰ (1999.3.10)

    $rec_size = 0;
    foreach $key (keys %cnt)
    {
        $rec_size += $cnt{$key};
    }
    return $rec_size;
}



#
# ڿ  ̿ <BR> ٿ(Word Wrap)
#
sub wordwrap
{
    local($ostr, $cols, $cmd) = @_;
    local @nstr;
    local $hcode;
    local $i;
    local $j;


    @nstr = "";
    @nstr = split(//, $ostr);
    $nstr2 = "";
    $j = 0;
    $hcode = 0;
    for $i (0..$#nstr)
    {
        if (ord($nstr[$i]) > 127)
        {
            if ($hcode == 1)
            {
                $hcode = 2;
            }
            else
            {
                $hcode = 1;
            }
        }
        else
        {
            $hcode = 0;
        }
        if ($nstr[$i] eq "\n")
        {
            $nstr2 = "$nstr2"."<BR>";
            $j = 0;
        }
        else
        {
            if ($j >= $cols - 1) #  ̸̻ ٷ ѱ.
            {
                if ($cmd eq "cut") # cut  ̸̻ ڸ.
                {
                    $nstr2 = "$nstr2"."~";
                    last;
                }
                if ($hcode == 1) # ord ascii Ѱ.
                {
                    $nstr2 = "$nstr2"."<BR>"."$nstr[$i]";
                }
                else
                {
                    $nstr2 = "$nstr2"."$nstr[$i]"."<BR>";
                }
                $j = 0;
            }
            else
            {
                $nstr2 = "$nstr2"."$nstr[$i]";
                $j++;
            }
        }
    }


    return $nstr2;
}



#
#  ȣ ϴ 
#
sub get_user_cryptedpasswd
{
    local($passwd_file, $req_user_id) = @_;
    local $i;
#    local $user_id, $user_cryptedpasswd; #   
    local $check_flag;


    open(PASSWD, "<$passwd_file") || print "## б ##\n";
    @rec = <PASSWD>;
    close(PASSWD);


    $check_flag = "none";
    for $i (0 .. $#rec)
    {
        chop($rec[$i]);
        if ($rec[$i] ne "")
        {
            ($user_id, $user_cryptedpasswd) = split(":", $rec[$i]);
            if ($user_id eq $req_user_id)
            {
                $check_flag = "exist";
                last;
            }
        }
    }
    if ($check_flag eq "exist")
    {
        return $user_cryptedpasswd;
    }
    else
    {
#        print "## $user_id ̵ ϵǾ  ʽϴ. ##\n";
        return "";
    }
}



#
# ȣ ϴ  ( ߰)
#
sub update_passwd
{
    local($passwd_file, $req_user_id, $req_user_uncryptedpasswd, $options) = @_;
    local $i;
#    local $user_id, $user_cryptedpasswd; #   
    local $check_flag;


    open(PASSWD, "<$passwd_file") || print "## б ##\n";
    @rec = <PASSWD>;
    close(PASSWD);


    open(PASSWD, ">$passwd_file") || print "## Ͼ ##\n";
    $check_flag = "none";
    for $i (0 .. $#rec)
    {
        chop($rec[$i]);
        if ($rec[$i] ne "")
        {
            ($user_id, $user_cryptedpasswd) = split(":", $rec[$i]);
            if ($user_id eq $req_user_id)
            {
                $cryptedpasswd = &make_passwd($req_user_uncryptedpasswd, $options);
                print PASSWD "$req_user_id:$cryptedpasswd\n";
                $check_flag = "exist";
                last;
            }
            else
            {
                print PASSWD "$rec[$i]\n";
            }
        }
    }
    if ($check_flag eq "exist")
    {
        return;
    }
    else
    {
        $cryptedpasswd = &make_passwd($req_user_uncryptedpasswd, $options);
        print PASSWD "$req_user_id:$cryptedpasswd\n";
        return;
    }    
}



#
# HTML ȵǰ ϴ  (1998.03.26)
#
sub no_html
{
    $html_text = $_[0];

    $html_text =~ s/</&lt;/g;   # '<' '&lt;' (HTML Ұϰ Ѵ.)
    $html_text =~ s/>/&gt;/g;   # '>' '&gt;' (HTML Ұϰ Ѵ.)
    $html_text =~ s/"/&quot;/g; # '"' '&quot;'

    return $html_text;
}



1; # null ƴ  ( ȵ.)
################################
#                              #
# Ⱑ  Դϴ. *^^* #
#                              #
################################
